var keyword = '';
var keywordID = '';
var sortType = 0;
var searchType = 0;
var searchTotalCount = 0;
var searchCurrentCount = 0;
var collectionList = [];

$(function(){
	// Lazy Load
	$('img.lazy').lazyload({
		effect: 'fadeIn',
		threshold: 50,
		placeholder: "/images/img/img-home-page/default.png"
	});
	updateCustomItemView();
	// Assign
	keyword = $('#search-keyword').val();
	keywordID = $('#search-keyword-id').val();
	$(".navigation-with-scroll #with-scroll-search-word").val(keyword);
	$(".nav-search-container .search-input-area #search-word").val(keyword);
	if (keyword.length > 7) {
		$(".recommand-tools-with-footer .tool-video").text("自己制作一个“" + keyword.substring(0, 6) +  "...”动图");
	} else {
		$(".recommand-tools-with-footer .tool-video").text("自己制作一个“" + keyword +  "”动图");
	}
	loadRelatedSubject(keyword, function(themeItem){
		var themeNode = createThemeItemNode(themeItem);
		$('#relate-wrapper .relate-theme').append(themeNode);
	});
	if ($('#search-total-count').val()) {
		searchTotalCount = parseInt($('#search-total-count').val());
	}
	if ($('#search-current-count').val()) {
		searchCurrentCount = parseInt($('#search-current-count').val());
	}
	var originURL = window.location.href.split('?')[0];
	var prefixURL = window.location.origin + '/gif/';
	var searchURL = originURL.replace(prefixURL, '').replace('.html', '');
	var searchParams = searchURL.split('-');
	var searchCurrentPage = 0;
	searchParams.forEach(function(value, index){
		if (index === 1) {
			var testNum = new RegExp(/^\d+$/);
			if (testNum.test(value)) {
				searchCurrentPage = parseInt(value);
			}
		} else if (index === 2) {
			var testSort = new RegExp(/(0|1)/);
			if (testSort.test(value)) {
				sortType = parseInt(value);
			}
		} else if (index === 3) {
			var testType = new RegExp(/(0|1|2)/);
			if (testType.test(value)) {
				searchType = parseInt(value);
			}
		}
	});
	if (sortType === 1) {
		$('#relate-wrapper .relate-bottom .tab-sort .tab-button.active').removeClass('active');
		$('#relate-wrapper .relate-bottom .tab-sort .tab-button[data-type="new"]').addClass('active');
	}
	if (searchType === 1 || searchType === 2) {
		$('#relate-wrapper .relate-bottom .tab-type .tab-button.active').removeClass('active');
		$('#relate-wrapper .relate-bottom .tab-type .tab-button[index=' + searchType + ']').addClass('active');
	}
	updateEmptyStatus();
	if (window.localStorage["state"] == 1) {
		var userID = window.localStorage['id'];
		loadCollectionData(userID, function(success, list){
			if (success === false) {
				return;
			}
			collectionList = [];
			list.forEach(function(item){
				collectionList.push(item.imageId);
			});
			updateCollectionStatus();
		});
	}


	/** 
	 * @msg 用户操作事件处理 
	 */ 
	// 工具入口 事件
	$('#tool-video').click(function(){
		var targetURL = window.location.origin + "/video";
        window.open(targetURL);
	});

	$('#tool-compose').click(function(){
		var targetURL = window.location.origin + "/gifTool";
        window.open(targetURL);
	});

	$('#tool-edit').click(function(){
		var targetURL = window.location.origin + "/editor";
        window.open(targetURL);
	});

	$('#tool-matting').click(function(){
		var targetURL = window.location.origin + "/matting";
        window.open(targetURL);
	});
	
	$('#tool-customize').click(function(){
        window.open("https://design.soogif.com");
	});

	$('.recommand-tools-with-footer .tool-video').click(function(){
		var targetURL = window.location.origin + "/video";
        window.open(targetURL);
	});
	
	// 用户点击 Both-Sides-Banner
    $('.recommand-banner-with-side').click(function(){
        var link = $(this).attr("data-href");
        if (link && link.length > 0) {
            window.open(link);
        }
    });

	// 用户点击 回到顶部
	$(".global-floating-container .global-floating-item.scroll-to-top").click(function() {
		$('body, html').animate({scrollTop: 0}, 300);
	});
	
	$(document).scroll(function(){
		var scrollOffsetY = $(window).scrollTop();
        if (scrollOffsetY > 300) {
            if ($('.global-floating-container').hasClass('active') === false) {
                $('.global-floating-container').addClass('active');
            }
        } else {
            if ($('.global-floating-container').hasClass('active')) {
                $('.global-floating-container').removeClass('active');
            }
        }
		if (scrollOffsetY < 2304) {
			$('.recommand-tools-with-footer').removeClass('active');
		} else {
			$('.recommand-tools-with-footer').addClass('active');
		}
	});

	// Tab Button：全部-表情-素材
	$('#relate-wrapper .relate-bottom .bottom-tab .tab-type .tab-button').click(function(){
		if ($(this).hasClass('active')) {
			return;
		}
		var index = $(this).index();
		if (index === 0) {
			_hmt.push(['_trackEvent', '260_web_search_switch', 'click', '260_web_搜索_切换_全部']);
		} else if (index === 1) {
			_hmt.push(['_trackEvent', '260_web_search_switch', 'click', '260_web_搜索_切换_表情']);
		} else {
			_hmt.push(['_trackEvent', '260_web_search_switch', 'click', '260_web_搜索_切换_素材']);
		}
		searchType = index;
		window.location.href = window.location.origin + '/gif/' + keywordID + '-1-' + sortType + '-' + searchType + '.html'
	});

    // Tab Button：热度-时间
    $('#relate-wrapper .relate-bottom .bottom-tab .tab-sort .tab-button').on('click',function(){
		if ($(this).hasClass('active')) {
			return;
		}
		var index = $(this).index();
		if (index === 0) {
			_hmt.push(['_trackEvent', '260_web_search_sort', 'click', '260_web_搜索_切换_热度']);
		} else {
			_hmt.push(['_trackEvent', '260_web_search_sort', 'click', '260_web_搜索_切换_时间']);
		}
		sortType = index;
		window.location.href = window.location.origin + '/gif/' + keywordID + '-1-' + sortType + '-' + searchType + '.html'
	});

	// 编辑图片
	$('#search-container .image-item .item-action .editor-btn').on('click',function(){
		if (window.localStorage['state'] != 1) {
			var senceParams = {
                senceId: 6,
				loginFrom: 3
            };
			handleLoginMessage(senceParams);
            return;
		}
		var editURL = $(this).attr('data-link');
        if (editURL && editURL.length > 0) {
            var targetURL = window.location.origin + "/editor?url=" + editURL;
            window.open(targetURL);
        }
	});
});

/**
 * @msg UI Update
 * @method	updateCustomItemView
 * @method	updateEmptyStatus
 * @method	updateCollectionStatus
 * @method	createThemeItemNode
 */
function updateCustomItemView() {
	loadSuggestionList(3, function(list){
		var centerItem, leftItem, rightItem;
		list.forEach(function(item){
			if (item.position === 'center') {
				centerItem = item;
			} else if (item.position === 'left') {
				leftItem = item;
			} else if (item.position === 'right') {
				rightItem = item;
			}
		});
		if (centerItem) {
			$('#search-container .custom-item').attr('href', centerItem.link);
			$('#search-container .custom-item > img').attr('src', centerItem.cover);
		}
		if (leftItem) {
			$('.recommand-banner-with-side.left').append('<img src="' + leftItem.cover + '" />');
			$('.recommand-banner-with-side.left').attr('data-href', leftItem.link);
			$('.recommand-banner-with-side.left').addClass('active');
		}
		if (rightItem) {
            $('.recommand-banner-with-side.right').append('<img src="' + rightItem.cover + '" />');
			$('.recommand-banner-with-side.right').attr('data-href', rightItem.link);
			$('.recommand-banner-with-side.right').addClass('active');
		}
	});
}

function updateEmptyStatus() {
	if (searchTotalCount === 0) {
		$('#search-empty-wrapper').addClass('active');
		$('#search-empty-wrapper').attr('data-type', 'empty');
		$('#search-empty-wrapper .empty-placeholder').attr('src', '/images/img/img-home-page/search-empty.jpg');
	} else if (searchCurrentCount === 0 || searchTotalCount < searchCurrentCount) {
		$('#search-empty-wrapper').addClass('active');
		$('#search-empty-wrapper').attr('data-type', 'limit');
	} else if ($('#search-container').height() === 0) {
		$('#search-empty-wrapper').addClass('active');
		$('#search-empty-wrapper').attr('data-type', 'limit');
	}
}

function updateCollectionStatus() {
	$('.image-item').each(function(){
		var imageID = $(this).attr('id');
		if (imageID && collectionList.indexOf(imageID) > -1) {
			$('#' + imageID + ' .item-action .collection-btn').addClass('active');
		}
	});
}

function createThemeItemNode(item) {
	var nodeHTML = '';
	nodeHTML += '<div class="relate-theme-content">';
	nodeHTML += '<div class="theme-title">';
	nodeHTML += '<span>“' + item.title + '”专题</span>';
	if (item.classLabel === '斗图') {
		nodeHTML += '<a href="/thematic-summary/detail.html?sid=' + item.sid + '&stitle=' + encodeURI(item.title) + '" target="_blank" >查看更多</a>';
	} else {
		nodeHTML += '<a href="/theme/' + item.sid + '" target="_blank" >查看更多</a>';
	}
	nodeHTML += '</div>';
	nodeHTML += '<div class="theme-list">';
	for (var index = 0; index < item.materialApplQueryVOList.length; index++) {
		if (index > 3) {
			break;
		}
		var imageItem = item.materialApplQueryVOList[index];
		nodeHTML += '<a class="image-item theme-item" id="' + imageItem.sid + '" href="/materialPage/' + imageItem.sid + '" title="' + imageItem.subText + '" click_from ="search" target="_blank">';
		nodeHTML += '<img src="' + imageItem.url + '_s280x0" alt="' + imageItem.subText + '" oncontextmenu="return false;" ondragstart="return false;" />';
		nodeHTML += '<div class="item-action">';
		nodeHTML += '<button class="collection-btn"></button>';
		nodeHTML += '</div>';
		nodeHTML += '<div class="item-labels">';
		if (imageItem.subText) {
			var labelList = imageItem.subText.split(' ');
			for (var i = 0; i < labelList.length; i++) {
				if (i > 3) {
					break;
				}
				if (labelList[i].length > 0) {
					nodeHTML += '<span>#' + labelList[i] + '</span>';
				}
			}
		}
		nodeHTML += '</div>';
		nodeHTML += '</a>';
	}
	nodeHTML += '</div>';
	nodeHTML += '</div>';

	return nodeHTML;
}


/** 
 * @msg API Request	
 * @method	loadRelatedSubject
 * @method	loadSuggestionList
 * @method	loadCollectionData
 */
function loadRelatedSubject(searchword, callback) {
	$.ajax({
		type: 'GET',
		url: '/search',
		data: {
			searchword: searchword
		},
		success: function(res){
			if (res.code === 200) {
				var themeList = res.data.themeList;
				if (themeList.length > 0) {
					callback(themeList[0]);
				}
			}
		}
	});
}

function loadCollectionData(userID, callback) {
	$.ajax({
		url: '/show',
		type: 'POST',
		dataType: 'JSON',
		data: {
			parentId: userID
		},
		success: function(res) {
			if (res.code === 200) {
				callback(true, res.result);
			} else {
				callback(false);
			}
		},
		error: function() {
			callback(false);
		}
	})
}

// load suggestion list
function loadSuggestionList(type, callback) {
	$.ajax({
		url: '/suggestion/getSuggestionList',
		type: 'GET',
		dataType: 'JSON',
		data: {
			pageType: type
		},
		success: function(res) {
			if (res.code === 200) {
				callback(res.data);
			}
		}
	});
}